(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
 Dmonstration de l'utilit des tables prcalcules : les fonctions COS     
 et SIN sont calcules lentement, m'astuce est de prcalcul tous les COS   
 et SIN pour les 360 utiliss.                                             
*)

{$N+ :Utilise le co-processeur arithtique (COS et SIN) }

uses Clavier, EcranVga;

var
  TableCos,TableSin : Array [0..359] of single;
  i,vram: word;

procedure PreCalcul; begin
  for i := 0 to 359 do begin
    TableCos [i] := Cos(i * Pi*2/180);
    TableSin [i] := Sin(i * Pi*2/180);
  end;
end;

procedure CercleLent (X,Y,Rayon : word; Coul: byte); begin
  for i := 0 to 359 do
    PutPixel (X +Round(Cos(i *PI/180) * Rayon),Y +Round(Sin(i *Pi/180) * Rayon),Coul);
end;

procedure Cercle (X,Y,Rayon : word; Coul: byte); begin
  for i := 0 to 359 do
    PutPixel (X +Round(TableCos[i] * Rayon),Y +Round(TableSin[i] * Rayon),Coul);
end;

procedure CercleOptimise (X,Y,Rayon : word; Coul: byte); begin
  for i := 0 to 359 do begin
    vram := Y +Round(TableSin[i] * Rayon);
    vram := vram shl 8 +vram shl 6 +(X +Round(TableCos[i] * Rayon));

    Mem[$A000: Vram] := Coul;
  end;
end;

begin
  ModeVga256;
  PreCalcul;

  EffaceEcran (0);
  repeat
     DessineCercle (Random (320),Random (200),
                 Random (50),
                 Random (255) );
     EcriVga (-1,0,'Unit EcranVGA',14,9);
  until TouchPresse; LitTouche;

  EffaceEcran (0);
  repeat
     CercleLent (Random (320),Random (200),
                 Random (50),
                 Random (255) );
     EcriVga (-1,0,'SANS table prcalcule',14,9);
  until TouchPresse; LitTouche;

  EffaceEcran (0);
  repeat
    Cercle (Random (320),Random (200),
            Random (50),
            Random (255) );
    EcriVga (-1,0,'AVEC table prcalcule',14,9);
  until TouchPresse; LitTouche;

  EffaceEcran (0);
  repeat
     CercleOptimise (Random (320),Random (200),
                 Random (50),
                 Random (255) );
     EcriVga (-1,0,'AVEC table +optimisation',14,9);
  until TouchPresse;

  ModeTxt;
end.